futhark-0.25.32: An optimising compiler for a functional, array-oriented language.

Safe Haskell | Safe-Inferred
Language | GHC2021

Futhark.Internalise.Lambdas

Synopsis

- type InternaliseLambda = Exp -> [Type] -> InternaliseM ([LParam SOACS], Body SOACS, [Type])
- internaliseFoldLambda :: InternaliseLambda -> Exp -> [Type] -> [Type] -> InternaliseM (Lambda SOACS)
- internalisePartitionLambda :: InternaliseLambda -> Int -> Exp -> [SubExp] -> InternaliseM (Lambda SOACS)

# Documentation

type InternaliseLambda = Exp -> [Type] -> InternaliseM ([LParam SOACS], Body SOACS, [Type]) Source #

A function for internalising lambdas.

internaliseFoldLambda :: InternaliseLambda -> Exp -> [Type] -> [Type] -> InternaliseM (Lambda SOACS) Source #

internalisePartitionLambda :: InternaliseLambda -> Int -> Exp -> [SubExp] -> InternaliseM (Lambda SOACS) Source #